﻿using DevExpress.XtraBars.Ribbon;
using DevExpress.XtraBars;
using DevExpress.XtraSplashScreen;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Configuration;
using FactoryTool.Properties;
using System.IO.Ports;

namespace FactoryTool
{
    public partial class MainView : DevExpress.XtraBars.Ribbon.RibbonForm
    {
        public MainView()
        {
            InitializeComponent();
            if (!mvvmContext1.IsDesignMode)
                InitializeBindings();

            //xtraTabbedMdiManager1.MdiParent = this;
            BurningForm xtraForm1 = new BurningForm();
            xtraForm1.MdiParent = this;
            xtraForm1.Show();


            ConfigurationForm xtraForm2 = new ConfigurationForm();
            xtraForm2.MdiParent = this;
            //xtraForm2.Show();

            // 设置当前活动窗口;
            //xtraTabbedMdiManager1.SelectedPage = xtraTabbedMdiManager1.Pages[xtraForm1];
            //设置标签后面添加删除按钮 ,  多个标签只需要设置一次
            //xtraTabbedMdiManager1.ClosePageButtonShowMode = DevExpress.XtraTab.ClosePageButtonShowMode.InAllTabPagesAndTabControlHeader;    
            //xtraTabbedMdiManager1.UseDocumentSelector = DevExpress.Utils.DefaultBoolean.False;
            //xtraTabbedMdiManager1.HeaderButtonsShowMode = DevExpress.XtraTab.TabButtonShowMode.Never;
            //xtraTabbedMdiManager1.PinPageButtonShowMode = DevExpress.XtraTab.PinPageButtonShowMode.InAllTabPageHeaders;
            
        }

        string[] skinsToHide = { "Basic", "The Bezier", "Xmas 2008 Blue", "Seven Classic", "DevExpress Style", "Dark", "2010", "2007", "Sharp" };

        private void HideGalleryItemsByCaptions(RibbonGalleryBarItem galleryItem, string[] skinsToHide)
        {
            var allItems = galleryItem.Gallery.GetAllItems();
            foreach (GalleryItem item in allItems)
            {
                if (skinsToHide.Contains(item.Caption))
                    item.Visible = false;
            }
        }

        private void InitializeBindings()
        {
            var fluent = mvvmContext1.OfType<MainViewModel>();
        }

        private void MainView_Load(object sender, EventArgs e)
        {
            LoginView loginView = new LoginView();
            if (loginView.ShowDialog() != DialogResult.OK)
            {
                Dispose();  // 使用Dispose时，主窗口退出不闪烁;
                // Application.Exit(); // 直接退出进程时，主窗口会闪烁;
                return;
            }
            else
            {
                // 显示欢迎界面;
                SplashScreenManager.ShowForm(typeof(WelcomeScreen));
                // 展示5秒;
                Thread.Sleep(3000);
                // 关闭欢迎界面;
                SplashScreenManager.CloseForm();

                HideGalleryItemsByCaptions(skinRibbonGalleryBarItem, skinsToHide);

                InitRibbonCtrl();
            }
        }

        private void skinRibbonGalleryBarItem1_Gallery_ItemClick(object sender, GalleryItemClickEventArgs e)
        {
            // 保存用户选择的皮肤;
            string SkinName = e.Item.Value.ToString();
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            if (config.AppSettings.Settings["Skin"] == null)
            {
                config.AppSettings.Settings.Add("Skin", SkinName);               
            }
            else
            {
                config.AppSettings.Settings["Skin"].Value = SkinName;
            }
            config.Save(ConfigurationSaveMode.Modified);
            ConfigurationManager.RefreshSection(config.AppSettings.SectionInformation.Name);
        }

        /// <summary>
        /// 初始化Ribbon面板;
        /// </summary>
        private void InitRibbonCtrl()
        {
            repositoryItemComboBox3.Items.AddRange(SerialPort.GetPortNames());
        }
    }
}
